/*
-*- coding: utf-8 -*-
gs.maxMonoConfigClient v0.020
Copyright (c) 2010, TJ Usiyan a.k.a. griotspeak
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
	* Redistributions of source code must retain the above copyright
	  notice, this list of conditions and the following disclaimer.
	* Redistributions in binary form must reproduce the above copyright
	  notice, this list of conditions and the following disclaimer in the
	  documentation and/or other materials provided with the distribution.
	* Neither the name of the MaxConfig nor the
	  names of its contributors may be used to endorse or promote products
	 derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY TJ USIYAN ``AS IS'' AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL TJ USIYAN BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

autowatch = 1;

inlets = 2;
outlets = 3;

var debugLevel;
//declareattribute("debugLevel",	null,			"setDebugLevel",			1);
setDebugLevel(0);

var windowWidth = 8;			// used by client
var windowHeight = 8;			// used by client
var windowColumnOffset = 0;		// used by client
var windowRowOffset = 0;		// used by client

var Monome = [];
var monomeWidth = 8;
var monomeHeight = 8;
declareattribute( "monomeWidth", null, null, 1);
declareattribute( "monomeHeight", null, null, 1);

declareattribute( "windowWidth", "getWindowWidth", "setWindowWidth", 1);
declareattribute( "windowHeight", "getWindowHeight", "setWindowHeight", 1);
declareattribute( "windowColumnOffset", "getWindowColumnOffset", "setWindowColumnOffset", 1);
declareattribute( "windowRowOffset", "getWindowRowOffset", "setWindowRowOffset", 1);

var displayColumnOffset = 0;	// used by router
var displayRowOffset = 0;		// used by router
declareattribute( "displayColumnOffset", "getDisplayColumnOffset", "setDisplayColumnOffset", 1);
declareattribute( "displayRowOffset", "getDisplayRowOffset", "setDisplayRowOffset", 1);

buildMonome();



//						---===Abstraction is a pain ===---
//			We do --NOT-- include edges
// 			greater than and less than
//			NOT equal to
function leftEdgeOfDisplayedWindow(){
	return windowColumnOffset - 1;
}

function rightEdgeOfDisplayedWindow() {
	return windowColumnOffset + windowWidth;
}

function topEdgeOfWindow() {
	return windowRowOffset -1;
}

function bottomEdgeOfWindow() {
	return windowRowOffset + windowHeight;
}

//						---===Getter and Setter Functions===---
function getWindowWidth() { return windowWidth; }

function setWindowWidth(_value) {
	if (debugLevel[6]) { post("					 --setWindowWidth-\n"); }
	
	windowWidth = _value;
	if (channelMade) {
		mcGlobal.appWindow(appName, appChannelNumber, randomKeyOne, randomKeyTwo, windowWidth, windowHeight, displayColumnOffset, displayRowOffset);
	}
}

function getWindowHeight() { return windowHeight; }

function setWindowHeight(_value) {
	if (debugLevel[6]) { post("					 ---setWindowHeight-\n"); }
	
	windowHeight = _value;
	if (channelMade) {
		mcGlobal.appWindow(appName, appChannelNumber, randomKeyOne, randomKeyTwo, windowWidth, windowHeight, displayColumnOffset, displayRowOffset);
	}
}

function getWindowColumnOffset() { return windowColumnOffset; }

function setWindowColumnOffset(_value) {
	if (debugLevel[1]) { post("					 ---setWindowColumnOffset-\n"); }
	
	clearWindow();
	if (_value < 0) {
		windowColumnOffset = 0;
	}
	else if ((0 <= _value) && (_value < monomeWidth - 1)) {
	    windowColumnOffset = _value;
	}
	else if (monomeWidth - 1 < _value) {
		windowColumnOffset = monomeWidth - 2;
	}
	
	// update
	if (channelMade) {
        refreshWindow();
    }
}

function getWindowRowOffset() { return windowRowOffset; }

function setWindowRowOffset(_value) {
	if (debugLevel[1]) { post("					 ---setWindowRowOffset-\n"); }
	
	
	clearWindow();
	if (_value < 0) {
		windowRowOffset = 0;
	}
	else if ((0 <= _value) && (_value < monomeHeight - 1)) {
	    windowRowOffset = _value;
	}
	else if (monomeWidth - 1 < _value) {
		windowRowOffset = monomeHeight - 2;
	}
	
	// update
	if (channelMade) {
        refreshWindow();
    }
}

function getDisplayColumnOffset() { return displayColumnOffset; }

function setDisplayColumnOffset(_value) {
	if (debugLevel[1]) { post("					 --setDisplayColumnOffset--\n"); }
	
	if (channelMade) {
		displayColumnOffset = _value;
		if (debugLevel[5]) { 
			post("appName:", appName, "\n");
			post("appChannelNumber:", appChannelNumber, "\n");
			post("randomKeyOne:", randomKeyOne, "\n");
			post("randomKeyTwo:", randomKeyTwo, "\n");
		}
		mcGlobal.appWindow(appName, appChannelNumber, randomKeyOne, randomKeyTwo, windowWidth, windowHeight, displayColumnOffset, displayRowOffset);
	}
}

function getDisplayRowOffset() { return displayRowOffset; }

function setDisplayRowOffset(_value) {
	if (debugLevel[1]) { post("					 ---setDisplayRowOffset-\n"); }
	
	if (channelMade) {
		displayRowOffset = _value;
		if (debugLevel[5]) { 
			post("appName:", appName, "\n");
			post("appChannelNumber:", appChannelNumber, "\n");
			post("randomKeyOne:", randomKeyOne, "\n");
			post("randomKeyTwo:", randomKeyTwo, "\n");
		}
		mcGlobal.appWindow(appName, appChannelNumber, randomKeyOne, randomKeyTwo, windowWidth, windowHeight, displayColumnOffset, displayRowOffset);
	}
}

function incrementDisplayColumnOffset() {
	var _valueHolder = getDisplayColumnOffset() + 1;
	setDisplayColumnOffset(_valueHolder);
}

function decrementDisplayColumnOffset() {
	var _valueHolder = getDisplayColumnOffset() - 1;
	setDisplayColumnOffset(_valueHolder);
}

function incrementDisplayRowOffset() {
	var _valueHolder = getDisplayRowOffset() + 1;
	setDisplayRowOffset(_valueHolder);
}

function decrementDisplayRowOffset() {
	var _valueHolder = getDisplayRowOffset() - 1;
	setDisplayRowOffset(_valueHolder);
}


//						---===Debugging Functions and Variables===---
//debugLevel[1] = true;
//debugLevel[2] = true;
//debugLevel[3] = true;
//debugLevel[4] = true;
//debugLevel[5] = true;
//debugLevel[6] = true;

// 0 - silence
// 1 - function name at start
// 2 - function end
// 3 - variables at end of function
// 4 - variables at start of function
// 5 - lists. so many lists.
// 6 - setters and getters

function setDebugLevel(level) {
	if (level > 0) { post("								--setDebugLevel for Client--", level, "\n"); }
	debugLevel = new Array();
	 for (var c = 0; c < 6; c++) {
		if (c <= level) {
			debugLevel[c] = true;
		}
		else {
			debugLevel[c] = false;
		}
	}
}

var randomKeyOne = Math.floor(Math.random()*1001); //number between 0 to 1000
var randomKeyTwo = Math.floor(Math.random()*1001); //number between 0 to 1000

var appName = jsarguments[1];
var appChannelNumber = null;
var channelMade = false;

mcGlobal = new Global("maxMonoConfigGlobal");
mcGlobal.appList = new Array();

function newRouterAlert(args) {
	alertRouterOfNewClient();
}

function hasChannel() {
	if (appChannelNumber == null) { return 0; }
	else { return 1; }
}

function alertRouterOfNewClient() {
	if (debugLevel[1]) { post("								--alertRouterOfNewClient--\n"); }
	
	// send: "newClientNotification"
	// 0<appName> 1<randomKey> 2<hasChannel> 3<channelIfAssigned>
	// 4<windowWidth> 5<height> 6<windowWidthOffset> 7<heightOffset>
	mcGlobal.newClient(appName, randomKeyOne, randomKeyTwo, windowWidth, windowHeight, displayColumnOffset, displayRowOffset);
}

function loadbang() {
	if (debugLevel[1]) { post("					 ---loadbang-\n"); }
	
	alertRouterOfNewClient();
	
}

function freebang () {
	if (debugLevel[1]) { post("					 ---freebang-\n"); }
	
	alertRouterofClientRemoval();
}

function alertRouterofClientRemoval() {
	if (debugLevel[1]) { post("					 ---alertRouterofClientRemoval-\n"); }
	
	var appNotification = [appName, randomKeyOne, randomKeyTwo];
	sendToRouter("removeClient", appNotification);
}


function clientAcknowledgement(_name, _channelNum, _key1, _key2) {
	if (debugLevel[1]) { post("					 ---processClientAcknowledgement-\n"); }
	
	if (debugLevel[5]) { 
		post("full array:", _name, _channelNum, _key1, _key2, "\n");
		post("client name:", _name, "channel num:", _channelNum, "client key 1:", _key1, " key 2:", _key2, "\n");
		post("my name:", appName, "and keys:", randomKeyOne, randomKeyTwo, "\n");
	}
	if((_name == appName) && (_key1 == randomKeyOne) && (_key2 == randomKeyTwo)) {
		if (debugLevel[3]) { post("channel:", _channelNum, "\n"); }
		//make the send and recieve objects.
		makeChannel(_channelNum);
	}
}

function prepareLedForRouter(_columnFromMonomeFunction, _rowFromMonomeFunction, _stateFromMonomeFunction) {	
	if (debugLevel[1]) { post("					 ---prepareLedForRouter-\n"); }
	
	translatedColumn = _columnFromMonomeFunction - windowColumnOffset;
	translatedRow = _rowFromMonomeFunction - windowRowOffset;
	
	if (isInWindow(_columnFromMonomeFunction, _rowFromMonomeFunction && channelMade)) {
		if (debugLevel[3]) { post("in window and channel made!\n"); }
		mcGlobal.led(appName, appChannelNumber, randomKeyOne, randomKeyTwo, translatedColumn, translatedRow, _stateFromMonomeFunction);
	}
}

function isInWindow(_columnInQuestion, _rowInQuestion) {
	if (debugLevel[1]) { post("					 --isInWindow--\n"); }
	
	
	if (debugLevel[5]) {
		post("col:", _columnInQuestion, "row:", _rowInQuestion, "\n");
		post("leftEdgeOfDisplayedWindow:", leftEdgeOfDisplayedWindow(), "\n");
		post("rightEdgeOfDisplayedWindow:", rightEdgeOfDisplayedWindow(), "\n");
		post("topEdgeOfWindow:", topEdgeOfWindow(), "\n");
		post("bottomEdgeOfWindow:", bottomEdgeOfWindow(), "\n");
	}
	
	
	if ((leftEdgeOfDisplayedWindow() < _columnInQuestion < rightEdgeOfDisplayedWindow()) && (topEdgeOfWindow() < _rowInQuestion < bottomEdgeOfWindow())) {
		return true;
	}
	else {
		return false;
	}
}

function sendToRouter(key, value) {
	if (debugLevel[1]) { post("								--sendToHud--\n"); }

	if (debugLevel[5]) { post("key:", key, "value:", value, "\n"); }
		outlet(0, key, value);
}

function makeChannel(_channelNum) {
	if (debugLevel[1]) { post("					 ---makeChannel-\n"); }
	
	appChannel = null;
	appChannelNumber = _channelNum;
	var channelName = appName + _channelNum;
	appChannel = new Global(channelName);
	if (debugLevel[4]) { 
		post("channelName in client:", channelName, "\n");
		post("channel", appName + _channelNum, "created\n");
	}
	appChannel.connection = processMessagesOnPrivateChannel;
	appChannel.press = processPress;
	
	channelMade = true;
}

function processPress(_columnFromRouter, _rowFromRouter, _stateFromRouter) {
	if (debugLevel[1]) { post("					 ---press-\n"); }
	if (debugLevel[3]) { post("column", _columnFromRouter, "row", _rowFromRouter, "state", _stateFromRouter ); }
	
	translatedColumn = _columnFromRouter + windowColumnOffset;
	translatedRow = _rowFromRouter + windowRowOffset;
	
	//		not doing anything with this yet, but eventually
	if (_stateFromRouter == 1) {
		Monome[translatedColumn][translatedRow].push();
	}
	else if(_stateFromRouter == 0) {
		Monome[translatedColumn][translatedRow].release();
	}	
	//		-/
	
	outlet(0, translatedColumn, translatedRow, _stateFromRouter);
}


function processMessagesOnPrivateChannel(_array) {
	if (debugLevel[1]) { post("					 ---processMessagesOnPrivateChannel-\n"); }

	post("app:", appName, "array:", _array, "\n");
}

function led (_columnFromPatcher, _rowFromPatcher, _stateFromPatcher) {
	if (debugLevel[1]) { post("					 ---led-\n"); }
	
	if (debugLevel[4]) { post("raw col:", _columnFromPatcher, "row:", _rowFromPatcher, "\n"); }

	
	if (_stateFromPatcher == 1) {
		Monome[_columnFromPatcher][_rowFromPatcher].ledOn();
	}
	else if(_stateFromPatcher == 0) {
		Monome[_columnFromPatcher][_rowFromPatcher].ledOff();
	}
}

function ledCol (_columnFromPatcher, _stateFromPatcher) {
	if (debugLevel[1]) { post("					 ---ledCol-\n"); }
	
	var decimalNumberValue = Number(_stateFromPatcher);
	var binaryNumberValue = decimalNumberValue.toString(2); // little endian
	if (debugLevel[4]) { post("raw col:", _columnFromPatcher, "decimal:", _stateFromPatcher, "binary:", binaryNumberValue, "\n"); }
	
	var lengthOfBinary = binaryNumberValue.length; 
	for (var r = 0; r < lengthOfBinary; r++) {
		
		if (binaryNumberValue[r] == 1) {
			Monome[_columnFromPatcher][lengthOfBinary - r - 1].ledOn();
		}
		else if(binaryNumberValue[r] == 0) {
			Monome[_columnFromPatcher][lengthOfBinary - r - 1].ledOff();
		}
	}
}

function ledRow (_rowFromPatcher, _stateFromPatcher) {
	if (debugLevel[1]) { post("					 ---ledCol-\n"); }
	
	var decimalNumberValue = Number(_stateFromPatcher);
	var binaryNumberValue = decimalNumberValue.toString(2); // little endian
	if (debugLevel[4]) { post("raw row:", _columnFromPatcher, "decimal:", _stateFromPatcher, "binary:", binaryNumberValue, "\n"); }
	
	var lengthOfBinary = binaryNumberValue.length; 
	for (var c = 0; c < lengthOfBinary; c++) {
		
		if (binaryNumberValue[r] == 1) {
			Monome[lengthOfBinary - c - 1][_rowFromPatcher].ledOn();
		}
		else if(binaryNumberValue[r] == 0) {
			Monome[lengthOfBinary - c - 1][_rowFromPatcher].ledOff();
		}
	}
}

//                                  ---===Monome Device Methods===---
function setMonomeWidth( mWidth) {
    if (debugLevel[1]) { post("                               --setMonomeWidth--\n"); }
    monomeWidth = mWidth;
    if(debugLevel[2]) { post("monomeWidth:", monomeWidth, "\n"); }
}
function setMonomeHeight( mHeight) {
    if (debugLevel[1]) { post("                               --setMonomeHeight--\n"); }
    monomeHeight = mHeight;
    if(debugLevel[2]) { post("monomeHeight:", monomeHeight, "\n"); }
}
function SingleCell(col, row) {
    this.outlet = 0;

    this.col = col;
    this.row = row;
    
    // local variables
    this.actualState = 0;
    this.tempState =  0;
    this.isHeld = 0;

    this.checkHeld = function() {
        return this.isHeld;
    };

    this.push = function() {
        this.isHeld = 1;
        return this.isHeld;
    };

    this.release = function() {
        this.isHeld = 0;
        return this.isHeld;
    };

    this.ledOn = function() {
        this.actualState = 1;
        prepareLedForRouter(this.col, this.row, this.actualState);
    };

    this.ledOff = function() {
        this.actualState = 0;
        prepareLedForRouter(this.col, this.row, this.actualState);
    };

    this.checkActual = function() {
        prepareLedForRouter(this.col, this.row, this.actualState);
        this.tempState = 0;
    };

    this.blink = function() {
        this.tempState = (this.tempState == 1) ? 0:1;
        prepareLedForRouter(this.col, this.row, this.tempState);
    };

    this.blinkIfOff = function() {
        if (this.actualState == 0) {
            this.tempState = (this.tempState == 1) ? 0:1;
            prepareLedForRouter(this.col, this.row, this.tempState);
        }
    };

    this.tempOn = function() {
        this.tempState = 1;
        prepareLedForRouter(this.col, this.row, this.tempState);
    };

    this.tempOff = function() {
        this.tempState = 0;
        prepareLedForRouter(this.col, this.row, this.tempState);
    };
}

function buildMonome() {
    if (debugLevel[1]) { post("                               --buildMonome--\n"); }
    if (debugLevel[4]) {
        post("monomeWidth:", monomeWidth, "\n");
        post("monomeHeight:", monomeHeight, "\n");
    }
    
    for (var w = 0; w < (monomeWidth); w++) {
        Monome[w] = new Array();
        for (var h = 0; h < (monomeHeight); h++) {
            Monome[w][h] = new SingleCell(w , h);
        }
    }
}

Monome.row = function(mRow, methodToInvoke) {
        switch (methodToInvoke) {
            case "ledOn":
                var cc;
                for (cc = 0; cc < monomeWidth; cc++) {
                    Monome[cc][mRow].ledOn();
                }
                break;
            case "ledOff":
                for (cc = 0; cc < monomeWidth; cc++) {
                    Monome[cc][mRow].ledOff();
                }
                break;
            case "tempOn":
                for (cc = 0; cc < monomeWidth; cc++) {
                    Monome[cc][mRow].tempOn();
                }
                break;
            case "tempOff":
                for (cc = 0; cc < monomeWidth; cc++) {
                    Monome[cc][mRow].tempOff();
                }
                break;
            case "blink":
                for (cc = 0; cc < monomeWidth; cc++) {
                    Monome[cc][mRow].blink();
                }
                break;
            case "blinkIfOff":
                for (cc = 0; cc < monomeWidth; cc++) {
                    Monome[cc][mRow].blinkIfOff();
                }
                break;
        }
};

Monome.column = function(mColumn, methodToInvoke) {
        switch (methodToInvoke) {
            case "ledOn":
                var cc;
                for (cc = 0; cc < monomeHeight; cc++) {
                    Monome[mColumn][cc].ledOn();
                }
                break;
            case "ledOff":
                for (cc = 0; cc < monomeHeight; cc++) {
                    Monome[mColumn][cc].ledOff();
                }
                break;
            case "tempOn":
                for (cc = 0; cc < monomeHeight; cc++) {
                    Monome[mColumn][cc].tempOn();
                }
                break;
            case "tempOff":
                for (cc = 0; cc < monomeHeight; cc++) {
                    Monome[mColumn][cc].tempOff();
                }
                break;
            case "blink":
                for (cc = 0; cc < monomeHeight; cc++) {
                    Monome[mColumn][cc].blink();
                }
                break;
            case "blinkIfOff":
                for (cc = 0; cc < monomeHeight; cc++) {
                    Monome[mColumn][cc].blinkIfOff();
                }
                break;
        }
};

function clearWindow() {
    if (debugLevel[1]) { post("                               --clearWindow--\n"); }
    var m;
    var n = Math.min(windowWidth + windowColumnOffset, monomeWidth);
	var o;
	var p = Math.min(windowHeight + windowRowOffset, monomeHeight);
	

    for (m = windowColumnOffset; m < n; m++) {
        for (o = windowRowOffset; o < p; o++) {
			if (debugLevel[3]) { post("clear col:", m, "row:", o, "\n"); }
            Monome[m][o].tempOff();
        }
    }
}

function refreshWindow() {
    if (debugLevel[1]) { post("                               --refreshWindow--\n"); }
	
	clearWindow();
    var m;
    var n = Math.min(windowWidth + windowColumnOffset, monomeWidth);
	var o;
	var p = Math.min(windowHeight + windowRowOffset, monomeHeight);
	

    for (m = windowColumnOffset; m < n; m++) {
        for (o = windowRowOffset; o < p; o++) {
			if (debugLevel[3]) { post("refresh col:", m, "row:", o, "\n"); }
            Monome[m][o].checkActual();
        }
    }
}